local rName = GetRealmName();
local pName = UnitName("player");
local ooprocessed = 0;
local tooltips = {GameTooltip, ShoppingTooltip1, ShoppingTooltip2, ShoppingTooltip3, flagRSP2Info}
local GAMETOOLTIP_DEFAULT_BACKDROP = GameTooltip:GetBackdrop()
local GAMETOOLTIP_DEFAULT_BACKCOLOR = GameTooltip:GetBackdropColor()
local GAMETOOLTIP_DEFAULT_BORDERCOLOR = GameTooltip:GetBackdropBorderColor()
frspversion = GetAddOnMetadata("flagRSP2", "Version");

local L = LibStub("AceLocale-3.0"):GetLocale("flagRSP2", false)

flagRSP2.defaults = {
    char = {
		flagRSP2DBConverted = false,
	
		flagRSP2OptionsCharName = pName,
		flagRSP2OptionsCharTitle = "",
		flagRSP2OptionsPhysDesc = "",
		flagRSP2OptionsPhysDescVer = 0,
		flagRSP2OptionsCharStatus = 2,
		flagRSP2OptionsRPExp = 1,

		flagRSP2OptionsSaveDescCheck = true,
		flagRSP2OptionsShowDescCheck = true,
		flagRSP2OptionsTargetDescCheck = false,
		flagRSP2OptionsStickyDescCheck = false,
		flagRSP2OptionsHideCombatCheck = true,
		flagRSP2OptionsWordLimitCheck = true,
		flagRSP2OptionsAFKCheck = true,
		flagRSP2OptionsShowCharacterButton = true,

		flagRSP2TooltipLightModeCheck = false,
		flagRSP2TooltipTransparency = 0.7,
		flagRSP2TooltipFRSP2TTCheck = true,
		flagRSP2TooltipShowAddNameCheck = true,
		flagRSP2TooltipShowTitleCheck = true,
		flagRSP2TooltipShowGuildCheck = true,
		flagRSP2TooltipShowStatusCheck = true,
		flagRSP2TooltipShowPvPCheck = false,
		flagRSP2TooltipShowPvPTitleCheck = false,
		flagRSP2DescShowTitleCheck = true,
		flagRSP2DescShowStatusCheck = true,
		
		flagRSP25 = false,
		
		flagRSP2DescAutoDBCleanCheck = false,
		flagRSP2MMIconCheck = true,
		minimap = {
			hide = false,
		},
    },
}

----Profile Options
--Char Name
function flagRSP2:GetflagRSP2OptionsCharName()
	return flagRSP2.db.char.flagRSP2OptionsCharName
end
function flagRSP2:SetflagRSP2OptionsCharName(info, value)
	if (flagRSP2.db.char.flagRSP2OptionsCharName ~= value) then
		flagRSP2.db.char.flagRSP2OptionsCharName = value
		flagRSP2CharUpdate("textsendupdate")
	end
end
--Char Title
function flagRSP2:GetflagRSP2OptionsCharTitle()
	return flagRSP2.db.char.flagRSP2OptionsCharTitle
end
function flagRSP2:SetflagRSP2OptionsCharTitle(info, value)
	if (flagRSP2.db.char.flagRSP2OptionsCharTitle ~= value) then
		flagRSP2.db.char.flagRSP2OptionsCharTitle = value
		flagRSP2CharUpdate("textsendupdate")
	end
end
--Phys Desc
function flagRSP2:GetflagRSP2OptionsPhysDesc()
	return flagRSP2.db.char.flagRSP2OptionsPhysDesc
end
function flagRSP2:SetflagRSP2OptionsPhysDesc(info, value)
	if (flagRSP2.db.char.flagRSP2OptionsPhysDesc ~= value) then
		flagRSP2.db.char.flagRSP2OptionsPhysDesc = value
		flagRSP2CharUpdate("descupdate")
		flagRSP2.db.char.flagRSP2OptionsPhysDescVer = flagRSP2.db.char.flagRSP2OptionsPhysDescVer + 1
	end
end
--Status
function flagRSP2:GetflagRSP2OptionsCharStatus()
	return flagRSP2.db.char.flagRSP2OptionsCharStatus
end
function flagRSP2:SetflagRSP2OptionsCharStatus(info, value)
	if (flagRSP2.db.char.flagRSP2OptionsCharStatus ~= value) then
		flagRSP2.db.char.flagRSP2OptionsCharStatus = value
		flagRSP2CharUpdate("textsendupdate")
	end
end
--RP EXP
function flagRSP2:GetflagRSP2OptionsRPExp()
	return flagRSP2.db.char.flagRSP2OptionsRPExp
end
function flagRSP2:SetflagRSP2OptionsRPExp(info, value)
	if (flagRSP2.db.char.flagRSP2OptionsRPExp ~= value) then
		flagRSP2.db.char.flagRSP2OptionsRPExp = value
		flagRSP2CharUpdate("textsendupdate")
	end
end

--General Options
function flagRSP2:GetflagRSP2OptionsSaveDescCheck()
	return flagRSP2.db.char.flagRSP2OptionsSaveDescCheck
end
function flagRSP2:SetflagRSP2OptionsSaveDescCheck()
	flagRSP2.db.char.flagRSP2OptionsSaveDescCheck = not flagRSP2.db.char.flagRSP2OptionsSaveDescCheck
end
function flagRSP2:GetflagRSP2OptionsShowDescCheck()
	return flagRSP2.db.char.flagRSP2OptionsShowDescCheck
end
function flagRSP2:SetflagRSP2OptionsShowDescCheck()
	flagRSP2.db.char.flagRSP2OptionsShowDescCheck = not flagRSP2.db.char.flagRSP2OptionsShowDescCheck
end
function flagRSP2:GetflagRSP2OptionsTargetDescCheck()
	return flagRSP2.db.char.flagRSP2OptionsTargetDescCheck
end
function flagRSP2:SetflagRSP2OptionsTargetDescCheck()
	flagRSP2.db.char.flagRSP2OptionsTargetDescCheck = not flagRSP2.db.char.flagRSP2OptionsTargetDescCheck
end
function flagRSP2:GetflagRSP2OptionsStickyDescCheck()
	return flagRSP2.db.char.flagRSP2OptionsStickyDescCheck
end
function flagRSP2:SetflagRSP2OptionsStickyDescCheck()
	flagRSP2.db.char.flagRSP2OptionsStickyDescCheck = not flagRSP2.db.char.flagRSP2OptionsStickyDescCheck
end
function flagRSP2:GetflagRSP2OptionsHideCombatCheck()
	return flagRSP2.db.char.flagRSP2OptionsHideCombatCheck
end
function flagRSP2:SetflagRSP2OptionsHideCombatCheck()
	flagRSP2.db.char.flagRSP2OptionsHideCombatCheck = not flagRSP2.db.char.flagRSP2OptionsHideCombatCheck
end
function flagRSP2:GetflagRSP2OptionsWordLimitCheck()
	return flagRSP2.db.char.flagRSP2OptionsWordLimitCheck
end
function flagRSP2:SetflagRSP2OptionsWordLimitCheck()
	flagRSP2.db.char.flagRSP2OptionsWordLimitCheck = not flagRSP2.db.char.flagRSP2OptionsWordLimitCheck
end
function flagRSP2:GetflagRSP2OptionsAFKCheck()
	return flagRSP2.db.char.flagRSP2OptionsAFKCheck
end
function flagRSP2:SetflagRSP2OptionsAFKCheck()
	flagRSP2.db.char.flagRSP2OptionsAFKCheck = not flagRSP2.db.char.flagRSP2OptionsAFKCheck
end
function flagRSP2:GetflagRSP2OptionsShowCharacterButton()
	return flagRSP2.db.char.flagRSP2OptionsShowCharacterButton
end
function flagRSP2:SetflagRSP2OptionsShowCharacterButton()
	flagRSP2.db.char.flagRSP2OptionsShowCharacterButton = not flagRSP2.db.char.flagRSP2OptionsShowCharacterButton
	if flagRSP2.db.char.flagRSP2OptionsShowCharacterButton then
		flagRSP2CharacterAnchor:Show()
	else
		flagRSP2CharacterAnchor:Hide()
	end
end

--Tooltip/Description Pop Up Options
function flagRSP2:GetflagRSP2TooltipLightModeCheck()
	return flagRSP2.db.char.flagRSP2TooltipLightModeCheck
end
function flagRSP2:SetflagRSP2TooltipLightModeCheck()
	flagRSP2.db.char.flagRSP2TooltipLightModeCheck = not flagRSP2.db.char.flagRSP2TooltipLightModeCheck
	ToggleTooltip();
end

flagRSP2_tooltip_backdrop = {
	bgFile = [=[Interface\ChatFrame\ChatFrameBackground]=], 
	edgeFile = [=[Interface\AddOns\flagRSP2\images\edgefile.blp]=], 
	level = '0', 
	edgeSize = 6, 
	insets = { top = 4, left = 4, bottom = 4, right = 4 }
}
function ToggleTooltip()
	if (flagRSP2.db.char.flagRSP2TooltipLightModeCheck) then
		for _,v in ipairs(tooltips) do
			if v.flagRSP2_old then
				v:SetBackdrop( v.flagRSP2_old.bd )
				v:SetBackdropColor( v.flagRSP2_old.bdc )
				v:SetBackdropBorderColor( v.flagRSP2_old.bdbc )
			end
			v.flagRSP2_old = nil
	    end
		flagRSP2Info:SetBackdropColor(0, 0, 0, flagRSP2.db.char.flagRSP2TooltipTransparency)
		-- Try to play nice - when setting things back to default, if TipTac's loaded, let it take precedence and restore anything it wants now
		if TipTac then
			if type( TipTac.ApplySettings ) == "function" then
				TipTac:ApplySettings()
			end
		end
	else
		for _,v in ipairs(tooltips) do
			v.flagRSP2_old = {}
			v.flagRSP2_old.bd = v:GetBackdrop()
			v.flagRSP2_old.bdc = v:GetBackdropColor()
			v.flagRSP2_old.bdbc = v:GetBackdropBorderColor()
			v:SetBackdrop( flagRSP2_tooltip_backdrop )
			v:SetBackdropColor(0, 0, 0, flagRSP2.db.char.flagRSP2TooltipTransparency)
			v:SetBackdropBorderColor(0, 0, 0, 1)
	    end
		flagRSP2Info:SetBackdropColor(0, 0, 0, flagRSP2.db.char.flagRSP2TooltipTransparency)
	end
end

function flagRSP2:GetflagRSP2TooltipTransparency()
	return flagRSP2.db.char.flagRSP2TooltipTransparency
end
function flagRSP2:SetflagRSP2TooltipTransparency(info, val)
	flagRSP2.db.char.flagRSP2TooltipTransparency = val
	if not flagRSP2.db.char.flagRSP2TooltipLightModeCheck then
		for _, v in ipairs( tooltips ) do
			v:SetBackdropColor(0, 0, 0, flagRSP2.db.char.flagRSP2TooltipTransparency)
		end
	end
end

function flagRSP2:GetflagRSP2TooltipFRSP2TTCheck()
	return flagRSP2.db.char.flagRSP2TooltipFRSP2TTCheck
end
function flagRSP2:SetflagRSP2TooltipFRSP2TTCheck()
	flagRSP2.db.char.flagRSP2TooltipFRSP2TTCheck = not flagRSP2.db.char.flagRSP2TooltipFRSP2TTCheck
end
function flagRSP2:GetflagRSP2TooltipShowAddNameCheck()
	return flagRSP2.db.char.flagRSP2TooltipShowAddNameCheck
end
function flagRSP2:SetflagRSP2TooltipShowAddNameCheck()
	flagRSP2.db.char.flagRSP2TooltipShowAddNameCheck = not flagRSP2.db.char.flagRSP2TooltipShowAddNameCheck
end
function flagRSP2:GetflagRSP2TooltipShowTitleCheck()
	return flagRSP2.db.char.flagRSP2TooltipShowTitleCheck
end
function flagRSP2:SetflagRSP2TooltipShowTitleCheck()
	flagRSP2.db.char.flagRSP2TooltipShowTitleCheck = not flagRSP2.db.char.flagRSP2TooltipShowTitleCheck
end
function flagRSP2:GetflagRSP2TooltipShowGuildCheck()
	return flagRSP2.db.char.flagRSP2TooltipShowGuildCheck
end
function flagRSP2:SetflagRSP2TooltipShowGuildCheck()
	flagRSP2.db.char.flagRSP2TooltipShowGuildCheck = not flagRSP2.db.char.flagRSP2TooltipShowGuildCheck
end
function flagRSP2:GetflagRSP2TooltipShowStatusCheck()
	return flagRSP2.db.char.flagRSP2TooltipShowStatusCheck
end
function flagRSP2:SetflagRSP2TooltipShowStatusCheck()
	flagRSP2.db.char.flagRSP2TooltipShowStatusCheck = not flagRSP2.db.char.flagRSP2TooltipShowStatusCheck
end
function flagRSP2:GetflagRSP2TooltipShowPvPCheck()
	return flagRSP2.db.char.flagRSP2TooltipShowPvPCheck
end
function flagRSP2:SetflagRSP2TooltipShowPvPCheck()
	flagRSP2.db.char.flagRSP2TooltipShowPvPCheck = not flagRSP2.db.char.flagRSP2TooltipShowPvPCheck
end
function flagRSP2:GetflagRSP2TooltipShowPvPTitleCheck()
	return flagRSP2.db.char.flagRSP2TooltipShowPvPTitleCheck
end
function flagRSP2:SetflagRSP2TooltipShowPvPTitleCheck()
	flagRSP2.db.char.flagRSP2TooltipShowPvPTitleCheck = not flagRSP2.db.char.flagRSP2TooltipShowPvPTitleCheck
end
function flagRSP2:GetflagRSP2DescShowTitleCheck()
	return flagRSP2.db.char.flagRSP2DescShowTitleCheck
end
function flagRSP2:SetflagRSP2DescShowTitleCheck()
	flagRSP2.db.char.flagRSP2DescShowTitleCheck = not flagRSP2.db.char.flagRSP2DescShowTitleCheck
end
function flagRSP2:GetflagRSP2DescShowStatusCheck()
	return flagRSP2.db.char.flagRSP2DescShowStatusCheck
end
function flagRSP2:SetflagRSP2DescShowStatusCheck()
	flagRSP2.db.char.flagRSP2DescShowStatusCheck = not flagRSP2.db.char.flagRSP2DescShowStatusCheck
end

--Database Options
function flagRSP2:GetflagRSP2DescAutoDBCleanCheck()
	return flagRSP2.db.char.flagRSP2DescAutoDBCleanCheck
end
function flagRSP2:SetflagRSP2DescAutoDBCleanCheck()
	flagRSP2.db.char.flagRSP2DescAutoDBCleanCheck = not flagRSP2.db.char.flagRSP2DescAutoDBCleanCheck
end

--LibDBIcon Options
function flagRSP2:GetflagRSP2MMIconCheck()
	return flagRSP2.db.char.flagRSP2MMIconCheck
end
local icon = LibStub("LibDBIcon-1.0")
function flagRSP2:SetflagRSP2MMIconCheck()
	flagRSP2.db.char.flagRSP2MMIconCheck = not flagRSP2.db.char.flagRSP2MMIconCheck
	if (flagRSP2.db.char.flagRSP2MMIconCheck == true) then
		flagRSP2.db.char.minimap.hide = nil
		icon:Show("flagRSP2")
	else
		flagRSP2.db.char.minimap.hide = true
		icon:Hide("flagRSP2")
	end
end

local optionsvname = "flagRSP2 " .. frspversion

--NEVER CHANGE THE ORDER OF THESE!
local char_status = {
	[1] = L["FLAGRSP2_LUA_OOC"],
	[2] = L["FLAGRSP2_LUA_IC"],
	[3] = L["FLAGRSP2_LUA_LFC"],
	[4] = L["FLAGRSP2_LUA_ST"]
}
--NEVER CHANGE THE ORDER OF THESE!
local rp_exp = {
	[1] = L["FLAGRSP2_LUA_RP"],
	[2] = L["FLAGRSP2_LUA_CRP"],
	[3] = L["FLAGRSP2_LUA_FRP"],
	[4] = L["FLAGRSP2_LUA_BRP"],
	[5] = L["FLAGRSP2_LUA_MRP"]
}

flagRSP2.options = {
	name = "flagRSP2 " .. GetAddOnMetadata("flagRSP2", "Version"),
	handler = flagRSP2,
	type = 'group',
	args = {
		frsp2options = {
			name = "flagRSP2",
			desc = '',
			order = 1,
			type = 'group',
			args = {
				Profile = {
					name = "Character Profile",
					type = 'group',
					order = 1,
					guiInline = true,
					args = {
						flagRSP2OptionsCharName = {
							type = "input",
							name = L["FLAGRSP2_NAME_TEXT"],
							desc = L["FLAGRSP2_NAME_DESC"],
							get = "GetflagRSP2OptionsCharName",
							set = "SetflagRSP2OptionsCharName",
							multiline = false,
							width = 'full',
							order = 2
						},
						flagRSP2OptionsCharTitle = {
							type = "input",
							name = L["FLAGRSP2_TITLE_TEXT"],
							desc = L["FLAGRSP2_TITLE_DESC"],
							get = "GetflagRSP2OptionsCharTitle",
							set = "SetflagRSP2OptionsCharTitle",
							multiline = false,
							width = 'full',
							order = 3
						},
						flagRSP2OptionsPhysDesc = {
							type = "input",
							name = L["FLAGRSP2_DESC_TEXT"],
							desc = L["FLAGRSP2_DESC_DESC"],
							get = "GetflagRSP2OptionsPhysDesc",
							set = "SetflagRSP2OptionsPhysDesc",
							multiline = 13,
							width = 'full',
							order = 4
						},
						flagRSP2OptionsCharStatus = {
							type = "select",
							name = L["FLAGRSP2_LUA_CHARSTATUS"],
							desc = L["FLAGRSP2_LUA_CHARSTATUS_DESC"],
							get = "GetflagRSP2OptionsCharStatus",
							set = "SetflagRSP2OptionsCharStatus",
							values = char_status,
							order = 5
						},
						flagRSP2OptionsRPExp = {
							type = "select",
							name = L["FLAGRSP2_LUA_RPEXP"],
							desc = L["FLAGRSP2_LUA_RPEXP_DESC"],
							get = "GetflagRSP2OptionsRPExp",
							set = "SetflagRSP2OptionsRPExp",
							values = rp_exp,
							order = 6
						},
					},
				},
				General = {
					name = "flagRSP2 " .. GetAddOnMetadata("flagRSP2", "Version") .. " General Options",
					type = 'group',
					order = 2,
					guiInline = true,
					args = {
						flagRSP2OptionsSaveDescCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_SAVE_DESCRIPTIONS"],
							desc = L["FLAGRSP2_SAVE_DESCRIPTIONS_DESC"],
							get = "GetflagRSP2OptionsSaveDescCheck",
							set = "SetflagRSP2OptionsSaveDescCheck",
							width = 'full',
							order = 3,
						},
						flagRSP2OptionsShowDescCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_SHOW_TARGET_CHARACTER_DESCRIPTION"],
							desc = L["FLAGRSP2_SHOW_DESCRIPTION_ONLY_WHEN_TARGETTING_PLAYER_DESC"],
							get = "GetflagRSP2OptionsShowDescCheck",
							set = "SetflagRSP2OptionsShowDescCheck",
							width = 'full',
							order = 3,
						},
						flagRSP2OptionsTargetDescCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_SHOW_DESCRIPTION_ONLY_WHEN_TARGETTING_PLAYER"],
							desc = L["FLAGRSP2_SHOW_DESCRIPTION_ONLY_WHEN_TARGETTING_PLAYER_DESC"],
							get = "GetflagRSP2OptionsTargetDescCheck",
							set = "SetflagRSP2OptionsTargetDescCheck",
							width = 'full',
							order = 4,
						},
						flagRSP2OptionsStickyDescCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_STICKY_DESCRIPTION"],
							desc = L["FLAGRSP2_STICKY_DESCRIPTION_DESC"],
							get = "GetflagRSP2OptionsStickyDescCheck",
							set = "SetflagRSP2OptionsStickyDescCheck",
							width = 'full',
							order = 5,
						},
						flagRSP2OptionsHideCombatCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_HIDE_DESCRIPTIONS_DURING_AND_ENTERING_COMBAT"],
							desc = L["FLAGRSP2_HIDE_DESCRIPTIONS_DURING_AND_ENTERING_COMBAT_DESC"],
							get = "GetflagRSP2OptionsHideCombatCheck",
							set = "SetflagRSP2OptionsHideCombatCheck",
							width = 'full',
							order = 6,
						},
						flagRSP2OptionsWordLimitCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_CUT_OFF_TITLES"],
							desc = L["FLAGRSP2_CUT_OFF_TITLES_DESC"],
							get = "GetflagRSP2OptionsWordLimitCheck",
							set = "SetflagRSP2OptionsWordLimitCheck",
							width = 'full',
							order = 7,
						},
						flagRSP2OptionsAFKCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_AFK"],
							desc = L["FLAGRSP2_AFK_DESC"],
							get = "GetflagRSP2OptionsAFKCheck",
							set = "SetflagRSP2OptionsAFKCheck",
							width = 'full',
							order = 8,
						},
						flagRSP2OptionsShowCharacterButton = {
							type = 'toggle',
							name = L["FLAGRSP2_CB"],
							desc = L["FLAGRSP2_CB_DESC"],
							get = "GetflagRSP2OptionsShowCharacterButton",
							set = "SetflagRSP2OptionsShowCharacterButton",
							width = 'full',
							order = 8,
						},
					},
				},
				gametooltip = {
					name = 'Enhanced GameTooltip',
					type = 'group',
					order = 9,
					guiInline = true,
					args = {
						flagRSP2TooltipLightModeCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_LIGHT_MODE_TOOLTIP"],
							desc = L["FLAGRSP2_LIGHT_MODE_TOOLTIP_DESC"],
							get = "GetflagRSP2TooltipLightModeCheck",
							set = "SetflagRSP2TooltipLightModeCheck",
							width = 'full',
							order = 9,
						},
						flagRSP2TooltipTransparency = {
							type = 'range',
							name = L["FLAGRSP2_TOOLTIP_TRANSPARENCY"],
							desc = L["FLAGRSP2_TOOLTIP_TRANSPARENCY_DESC"],
							get = "GetflagRSP2TooltipTransparency",
							set = "SetflagRSP2TooltipTransparency",
							width = 'full',
							min = 0,
							max = 1,
							step = 0.1,
							order = 10,
						},
						flagRSP2TooltipShowAddNameCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_ENHANCED_ADDITIONAL_NAME"],
							desc = "",
							get = "GetflagRSP2TooltipShowAddNameCheck",
							set = "SetflagRSP2TooltipShowAddNameCheck",
							width = 'full',
							order = 10,
						},
						flagRSP2TooltipShowTitleCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_ENHANCED_TITLE"],
							desc = "",
							get = "GetflagRSP2TooltipShowTitleCheck",
							set = "SetflagRSP2TooltipShowTitleCheck",
							width = 'full',
							order = 11,
						},
						flagRSP2TooltipShowGuildCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_ENHANCED_GUILD"],
							desc = "",
							get = "GetflagRSP2TooltipShowGuildCheck",
							set = "SetflagRSP2TooltipShowGuildCheck",
							width = 'full',
							order = 12,
						},
						flagRSP2TooltipShowStatusCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_ENHANCED_STATUS"],
							desc = "",
							get = "GetflagRSP2TooltipShowStatusCheck",
							set = "SetflagRSP2TooltipShowStatusCheck",
							width = 'full',
							order = 13,
						},
						flagRSP2TooltipShowPvPCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_ENHANCED_PVP"],
							desc = "",
							get = "GetflagRSP2TooltipShowPvPCheck",
							set = "SetflagRSP2TooltipShowPvPCheck",
							width = 'full',
							order = 14,
						},
						flagRSP2TooltipShowPvPTitleCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_ENHANCED_PVP_TITLE"],
							desc = "",
							get = "GetflagRSP2TooltipShowPvPTitleCheck",
							set = "SetflagRSP2TooltipShowPvPTitleCheck",
							width = 'full',
							order = 15,
						},
					},
				},

				descpopup = {
					name = L["FLAGRSP2_DESC_OPT"],
					type = 'description',
					type = 'group',
					order = 16,
					guiInline = true,
					args = {
						flagRSP2DescShowTitleCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_DESC_TITLE"],
							desc = "",
							get = "GetflagRSP2DescShowTitleCheck",
							set = "SetflagRSP2DescShowTitleCheck",
							width = 'full',
							order = 17,
						},
						flagRSP2DescShowStatusCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_DESC_STATUS"],
							desc = "",
							get = "GetflagRSP2DescShowStatusCheck",
							set = "SetflagRSP2DescShowStatusCheck",
							width = 'full',
							order = 18,
						},
					},
				},
				minimap = {
					name = 'Minimap Icon Options',
					type = 'description',
					type = 'group',
					order = 20,
					guiInline = true,
					args = {
						flagRSP2MMIconHide = {
							type = 'toggle',
							name = L["FLAGRSP2_FUBAR_MINIMAP"],
							desc = L["FLAGRSP2_FUBAR_MINIMAP_DESC"],
							get = "GetflagRSP2MMIconCheck",
							set = "SetflagRSP2MMIconCheck",
							width = 'full',
							order = 21,
						},
					},
				},
				dbcleanup = {
					name = L["FLAGRSP2_DB_CLEAN_UP"],
					type = 'description',
					type = 'group',
					order = 23,
					guiInline = true,
					args = {
						purgeselectivedb = {
							type = 'execute',
							name = L["FLAGRSP2_DB_PURGE_OLD"],
							desc = L["FLAGRSP2_DB_PURGE_ALL_DESC"],
							func = function() flagRSP2PurgeOldDB() end,
							order = 24,
						},
						purgealldb = {
							type = 'execute',
							name = L["FLAGRSP2_DB_PURGE_ALL"],
							desc = L["FLAGRSP2_DB_PURGE_ALL_DESC"],
							func = function() flagRSP2PurgeAllDB() end,
							order = 25,
						},
						flagRSP2DescAutoDBCleanCheck = {
							type = 'toggle',
							name = L["FLAGRSP2_DB_AUTO_PURGE"],
							desc = L["FLAGRSP2_DB_AUTO_PURGE_DESC"],
							get = "GetflagRSP2DescAutoDBCleanCheck",
							set = "SetflagRSP2DescAutoDBCleanCheck",
							width = 'full',
							order = 26,
						},
					},
				},
			},
		},
	},
}

function flagRSP2Options_Initialize()
	local desctext, i
	if (FlagList == nil) then
		FlagList = {};
	end
	if (FlagList[rName] == nil) then
		FlagList[rName] = {};
	end
	if (FlagList[rName][pName] == nil) then
		FlagList[rName][pName] = {};
	end
	if ( not flagRSP2DB[ "FlagListVersion" ] or flagRSP2DB[ "FlagListVersion" ] < 2 ) then
		-- Either converting to new or starting from scratch. Convert where necessary.
		for realm, t in pairs( FlagList ) do
			for char, u in pairs( t ) do
				if u.Desc then
					if u.Desc.A then
						i = 1
						desctext = ""
						while u.Desc.A[i] ~= nil do
							desctext = desctext .. u.Desc.A[i]
							i = i + 1
						end
						u.DE = strtrim( desctext:gsub( [[\l]], "\n" ):gsub( [[\\]], [[\]] ) )
						u.DE = ( u.DE ~= "" ) and u.DE or nil
					end
					u.Desc = nil
				end
				if u.Title then
					u.NT = strtrim( u.Title )
					u.NT = ( u.NT ~= "" and u.NT ) or nil
					u.Title = nil
				end
				if not u.NA then
					if u.AN1 or u.AN3 then
						u.NA = strtrim( strtrim( u.AN1 ) .. " " .. char .. " " .. strtrim( u.AN3 ) )
					end
				end
				u.AN1 = nil
				u.AN3 = nil
				if u.RPFlag then
					u.FR = u.RPFlag
					u.RPFlag = nil
				end
				if u.CSTATUS then
					u.FC = u.CSTATUS
					u.CSTATUS = nil
				end
			end
		end
		flagRSP2DB[ "FlagListVersion" ] = 2
	end

	if (flagRSP2.db.char.flagRSP2OptionsCharSuffix or flagRSP2.db.char.flagRSP2OptionsCharPrefix) then
		flagRSP2.db.char.flagRSP2OptionsCharName = strtrim( strtrim( flagRSP2.db.char.flagRSP2OptionsCharPrefix or "" ) .. " " .. pName .. " " .. strtrim( flagRSP2.db.char.flagRSP2OptionsCharSuffix or "" ) )
		flagRSP2.db.char.flagRSP2OptionsCharPrefix = nil
		flagRSP2.db.char.flagRSP2OptionsCharSuffix = nil
	end

	FRSPLOADED = 1;
end
